-- First successful use of bump.lua!  20.09.2017

local bump = require 'bump'

                                -- Create a Bump-World and
local world = bump.newWorld(50) -- specify the grid cell size! (default = 64)

local A = {name="A", x = 10, y = 10, w = 64, h = 156, speed = 180}

local B = {name="B", x = 130, y = 200, w = 32, h = 32, speed = 180}

world:add(A, A.x, A.y, A.w, A.h)     -- insert both rectangles into bump
world:add(B, B.x, B.y, B.w, B.h)   -- x,y, width, height


-- Player functions
local function updatePlayer(dt)
  local speed = A.speed

  local dx, dy = 0, 0
  if love.keyboard.isDown('right') then
    dx = speed * dt
  elseif love.keyboard.isDown('left') then
    dx = -speed * dt
  end
  if love.keyboard.isDown('down') then
    dy = speed * dt
  elseif love.keyboard.isDown('up') then
    dy = -speed * dt
  end

  if dx ~= 0 or dy ~= 0 then
    A.x, A.y, _, col_len = world:move(A, A.x + dx, A.y + dy)
  end
end


local function updateFoe(dt)
  local speed = B.speed

  local dx, dy = 0, 0
  if love.keyboard.isDown('d') then
    dx = speed * dt
  elseif love.keyboard.isDown('a') then
    dx = -speed * dt
  end
  if love.keyboard.isDown('s') then
    dy = speed * dt
  elseif love.keyboard.isDown('w') then
    dy = -speed * dt
  end

  if dx ~= 0 or dy ~= 0 then
    B.x, B.y, _, col_len = world:move(B, B.x + dx, B.y + dy)
  end
end




-- helper function
local function drawBox(box, r,g,b)
  love.graphics.setColor(r,g,b,70)
  love.graphics.rectangle("fill", box.x, box.y, box.w, box.h)
  love.graphics.setColor(r,g,b)
  love.graphics.rectangle("line", box.x, box.y, box.w, box.h)
end

local function drawPlayer()
  drawBox(A, 0, 255, 0)
end

local function drawFoe()
  drawBox(B, 0, 255, 255)
end



function love.update(dt)
  col_len = 0
  updatePlayer(dt)
  updateFoe(dt)
end


function love.draw()
  drawPlayer()
  drawFoe()
  -- if shouldDrawDebug then drawDebug() end
  -- drawMessage()
end

-- Non-player keypresses
function love.keypressed(k)
  if k=="escape" then love.event.quit() end
end

